<template>
  <v-data-table
    :server-items-length="pagination.total"
    :sort-by.sync="pagination.sortBy"
    :headers="headers"
    :items="rows"
    :items-per-page="pagination.pageSize"
    class="elevation-1 bulk-table"
    loading-text="Cargando datos de cargas masivas..."
    :loading="loading"
    :page="pagination.page"
    @click:row="handleClick"
  >
    <template #item.state="{ item }">
      {{ formatBulkState(item.state) }}
    </template>
    <template #item.type="{ item }">
      {{ formatBulkFileType(item.type) }}
    </template>
    <template #item.requestedAt="{ item }">
      {{ formatDateTimeToLocal(item.requestedAt) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { formatBulkFileType, formatBulkState, formatDateTimeToLocal } from '~/helpers/format';

export default {
  name: 'BulkLoadTable',
  data() {
    return {
      pagination: {
        descending: true,
        page: 1,
        pageSize: 10,
        total: 40,
        rowsPerPage: 3,
        sortBy: 'id',
        totalItems: 0,
        rowsPerPageItems: [1, 2, 4, 8, 16],
      },
      headers: [
        {
          text: 'N°',
          align: 'start',
          sortable: true,
          value: 'id',
        },
        { text: 'Nombre de archivo', value: 'filename' },
        { text: 'Tipo de carga', value: 'type' },
        { text: 'Hora de carga', value: 'requestedAt' },
        { text: 'Estado', value: 'state' },
      ],
      rows: [],
    };
  },
  computed: {
    ...mapState({
      allBulkLoads: state => state.bulk.allBulks,
      loading: state => state.bulk.loading,
    }),
  },
  mounted() {
    this.initialize();
  },
  methods: {
    ...mapActions({
      getAllCurrentBulkLoad: 'bulk/getAllCurrentBulkLoad',
    }),
    async initialize() {
      const params = { pageNumber: this.pagination.page, pageSize: this.pagination.pageSize };
      await this.getAllCurrentBulkLoad(params);
      this.setRows();
    },
    setRows() {
      this.rows = this.allBulkLoads.map(a => a.bulkLoad);
      console.log(this.rows);
    },
    handleClick(value) {
      this.$router.push('/cargas-masivas/' + value.id);
    },
    formatBulkFileType,
    formatBulkState,
    formatDateTimeToLocal,
  },
};
</script>

<style>
.bulk-table {
  width: 95%;
  margin-right: 2%;
}
</style>
